// LIFO dnaamilisel massiivil C++ stiilis (klassina)

#include <stdlib.h>//#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

const int TRUE=1, FALSE=0;

class LiFo       // klassi (uue andmetbi) definitsioon
{
    int maxHigh;          // maksimaalne elementide arv
    int count;            // tegelik elementide arv
    int * mass;          // viit massiivi algusele
    char * name;          // viit magasini nimetusele
  public:
    void init( int , char * );   // klassi meetodite prototbid
    int push( int value );
    int pop( int & value );
    void view();
};

void LiFo::init( int max, char * title )  // algseisu viimine
{
     mass = new int[max];       // reserveerime mlu massiivile
     // if( !mass ) pole mlu! 
     maxHigh = max;      // maksimaalne elementide arv
     count = 0;          // stack on thi
     int length = strlen(title);       
     name = new char[length+1];  // reserveerime mlu 
     strcpy( name, title );
}
int LiFo::push( int value )  
{
    if( count < maxHigh )  // kui on veel ruumi...
    {
        mass[count++] = value;    // lisame uue elemendi
        return TRUE;
    }
    else
        return FALSE;       // overflow
}
int LiFo::pop( int & value )
{
    if( !count ) return FALSE;   // underflow - stack on thi
    value = mass[--count];      // vastasel juhul: vtame elemendi tipust
    return TRUE;
}
void LiFo::view()
{
    printf("\"%s\" sisaldab %d elementi:   ",name,count);
    int * p = mass;
    for( int k=0; k<count; k++ )     // tskkel le elementide
       printf( "%d   ", *p++ );      // array[k]
    printf("\n");
}

//___________________________peaprogramm_____________________________________

int main()
{
    int element;
    srand( time(NULL) );  // initialize random number generator 
    LiFo teine;
    LiFo magasin;
    magasin.init( 21, "Minu stack " );
    
    for( int j=0; j<8; j++ )
    {
         magasin.push( rand()%100 );     // juhukas 0..99    
    }
    magasin.view();
    teine.init( 21, "Teine stack" );
    while( magasin.pop( element ) )     // kuni magasin ei ole thi...
         teine.push( element );
         teine.view();
    getchar();
    return 0;
}
    
  
